DCMTK - Bug #1154

Pad byte for decompressed JPEG-LS image incorrect on big endian hardware
2025-02-18 17:45 - Marco Eichelberg

Status: Closed Start date: 2025-02-18
Priority: Normal Due date:

Assignee: % Done: 100%
Category: Library and Apps Estimated time: 3:00 hours
Target version: 3.7.0

Module: dcmijpls Compiler:

Operating System:

Description

The JPEG-LS decompressor fails to correctly swap the last 16-bit word in the Pixel Data element, if the decompressed frame size is
an odd number of bytes, when run on Big Endian hardware. The same problem may affect other codecs as well.

The attached sample image demonstrates the issue - The decompressed result is different on Big Endian hardware compared to the
result produced on Little Endian hardware. Specifically, the last two bytes are swapped (shown here as a diff of the hexdump
output):

< 00025140 ae 92 76 00 [

> 00025140 ae 92 00 76 | o.o.v

This should be tested with a multi-frame test image with an odd number of bytes per frame.

History

#1 - 2025-02-26 17:48 - Marco Eichelberg
- Status changed from New to Closed

- % Done changed from 0 to 100

- Estimated time set to 3:00 h

Note: This issue only affected the JPEG-LS decoder, not any of the other compression codecs in DCMTK.

Closed by commit #84ae9c833.

Files

hp_color_transform_1.dcm 54.9 KB 2025-02-18 Marco Eichelberg
